Index: /java/main/src/main/java/com/framsticks/core/Entity.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Entity.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/core/Entity.java	(revision 78)
@@ -4,7 +4,4 @@
 import com.framsticks.util.Thread;
 import org.apache.log4j.Logger;
-
-import java.util.HashSet;
-import java.util.Set;
 
 /**
@@ -37,9 +34,9 @@
     }
 
-    public final void configurePublic() {
+    public final void configurePublic() throws Exception {
         configure();
     }
 
-    protected void configure() {
+    protected void configure() throws Exception {
 
     }
@@ -58,4 +55,11 @@
     }
 
+	public final void done() {
+		LOGGER.info("stopping entity");
+		if (owner != null) {
+			owner.onDone();
+		}
+	}
+
 
 }
Index: /java/main/src/main/java/com/framsticks/core/EntityOwner.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/EntityOwner.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/core/EntityOwner.java	(revision 78)
@@ -0,0 +1,8 @@
+package com.framsticks.core;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public interface EntityOwner {
+	void onDone();
+}
Index: /java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/core/Instance.java	(revision 78)
@@ -23,5 +23,4 @@
     protected Node root;
 
-	protected final Map<String, FramsClass> infoCache = new HashMap<String, FramsClass>();
     public Set<InstanceListener> listeners = new HashSet<InstanceListener>();
 
@@ -34,17 +33,43 @@
     protected void run() {
         super.run();
-        registerTypicalReflectedClasses();
+		com.framsticks.model.Package.register(registry);
     }
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
         super.configure();
     }
 
-    protected abstract void fetchInfo(Path path, Future<FramsClass> future);
-    public abstract void resolve(Path path, Future<Path> future);
-    public abstract void fetchValue(Path path, Param param, StateFunctor stateFunctor);
-    public abstract void fetchValues(Path path, StateFunctor stateFunctor);
-    protected abstract void tryRegisterOnChangeEvents(Path path);
+    protected void fetchInfo(Path path, Future<FramsClass> future) {
+		future.result(null, new UnsupportedOperationException());
+	}
+
+	public void resolve(Path path, Future<Path> future) {
+		assert isActive();
+		assert path.isOwner(this);
+		if (path.getTop().getObject() != null) {
+			future.result(path, null);
+			return;
+		}
+		AccessInterface access = bindAccess(path.getUnder());
+		Object object = access.get(path.getTop().getParam(), Object.class);
+		if (object == null) {
+			future.result(path, null);
+			return;
+		}
+		future.result(path.appendResolution(object), null);
+	}
+
+    public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
+		stateFunctor.call(null);
+	}
+
+    public void fetchValues(Path path, StateFunctor stateFunctor) {
+		stateFunctor.call(null);
+	}
+
+    protected void tryRegisterOnChangeEvents(Path path) {
+
+	}
 
 	public void storeValue(Path path, Param param, Object value, final StateFunctor stateFunctor) {
@@ -98,13 +123,4 @@
 	}
 
-	public void putInfoIntoCache(FramsClass framsClass) {
-        assert isActive();
-        if (infoCache.containsKey(framsClass.getId())) {
-            LOGGER.info("already cached " + framsClass);
-            return;
-        }
-        LOGGER.debug("caching info for " + framsClass);
-		infoCache.put(framsClass.getId(), framsClass);
-	}
 
     public final FramsClass getInfoFromCache(Path path) {
@@ -115,28 +131,8 @@
     public FramsClass getInfoFromCache(String id) {
         assert isActive();
-        if (id == null) {
-			return null;
-		}
-        if (infoCache.containsKey(id)) {
-            return infoCache.get(id);
-        }
-		return null;
-	}
-
-	protected final Map<String, Class> reflectedClasses = new HashMap<String, Class>();
-
-    public final void registerReflectedClass(String name, String className) {
-        assert isActive();
-        try {
-            registerReflectedClass(name, Class.forName(className));
-        } catch (ClassNotFoundException e) {
-            LOGGER.fatal("class not found during registration: " + e);
-        }
-    }
-
-    public void registerReflectedClass(String name, Class reflectedClass) {
-        assert isActive();
-        reflectedClasses.put(name, reflectedClass);
-	}
+		return registry.getInfoFromCache(id);
+	}
+
+	protected Registry registry = new Registry();
 
 	public AccessInterface createAccess(String name) {
@@ -150,9 +146,5 @@
 		}
 
-		if (reflectedClasses.containsKey(name)) {
-			return new ReflectionAccess(reflectedClasses.get(name), framsClass);
-		}
-
-		return new PropertiesAccess(framsClass);
+		return registry.createAccess(name, framsClass);
 	}
 
@@ -188,4 +180,5 @@
         AccessInterface access = prepareAccess(node.getParam());
         if (access == null) {
+			LOGGER.error("missing access for: " + node.getParam());
             return null;
         }
@@ -287,5 +280,5 @@
             }
         }
-        putInfoIntoCache(framsClass);
+        registry.putInfoIntoCache(framsClass);
         return framsClass;
     }
@@ -338,15 +331,4 @@
     }
 
-    public void registerTypicalReflectedClasses() {
-        registerReflectedClass("MechPart", "com.framsticks.model.MechPart");
-        registerReflectedClass("Joint", "com.framsticks.model.Joint");
-        registerReflectedClass("MechJoint", "com.framsticks.model.MechJoint");
-        registerReflectedClass("Neuro", "com.framsticks.model.Neuro");
-        registerReflectedClass("NeuroDef", "com.framsticks.model.NeuroDef");
-        registerReflectedClass("Part", "com.framsticks.model.Part");
-        registerReflectedClass("Creature", "com.framsticks.model.Creature");
-        registerReflectedClass("Genotype", "com.framsticks.model.Genotype");
-    }
-
     public static Iterator<String> splitPath(String path) {
         List<String> list = new LinkedList<String>();
@@ -359,3 +341,7 @@
     }
 
+	public Registry getRegistry() {
+		return registry;
+	}
 }
+
Index: /java/main/src/main/java/com/framsticks/core/LocalInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 78)
@@ -45,5 +45,5 @@
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
         super.configure();
     }
@@ -97,34 +97,3 @@
     }
 
-
-
-    @Override
-    public void resolve(Path path, Future<Path> future) {
-        assert isActive();
-        assert path.isOwner(this);
-        if (path.getTop().getObject() != null) {
-            future.result(path, null);
-            return;
-        }
-        AccessInterface access = bindAccess(path.getUnder());
-        Object object = access.get(path.getTop().getParam(), Object.class);
-        if (object == null) {
-            future.result(path, null);
-            return;
-        }
-        future.result(path.appendResolution(object), null);
-    }
-
-
-    @Override
-    public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
-        stateFunctor.call(null);
-    }
-
-    @Override
-    public void fetchValues(Path path, StateFunctor stateFunctor) {
-        stateFunctor.call(null);
-    }
-
-
 }
Index: /java/main/src/main/java/com/framsticks/core/Parameters.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Parameters.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/core/Parameters.java	(revision 78)
@@ -12,9 +12,13 @@
     protected String name;
     protected Dispatcher dispatcher;
+	protected EntityOwner owner;
 
-    public Parameters(Configuration config, String name, Dispatcher dispatcher) {
+
+
+    public Parameters(Configuration config, String name, Dispatcher dispatcher, EntityOwner owner) {
         this.config = config;
         this.name = name;
         this.dispatcher = dispatcher;
+		this.owner = owner;
     }
 
@@ -23,4 +27,5 @@
         name = parameters.name;
         dispatcher = parameters.dispatcher;
+		owner = parameters.owner;
     }
 
Index: /java/main/src/main/java/com/framsticks/core/Program.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Program.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/core/Program.java	(revision 78)
@@ -6,6 +6,6 @@
 import org.apache.log4j.Logger;
 import org.apache.log4j.PropertyConfigurator;
-import sun.misc.Signal;
-import sun.misc.SignalHandler;
+//import sun.misc.Signal;
+//import sun.misc.SignalHandler;
 
 import java.lang.reflect.Constructor;
@@ -19,4 +19,5 @@
     private final static Logger LOGGER = Logger.getLogger(Program.class.getName());
 
+/*
     protected SignalHandler signalHandler = new SignalHandler() {
         @Override
@@ -26,4 +27,5 @@
         }
     };
+*/
 
     protected Entity entity;
@@ -34,6 +36,6 @@
     public Program(String name) {
         super(name, java.lang.Thread.currentThread());
-        Signal.handle(new Signal("INT"), signalHandler);
-        Signal.handle(new Signal("TERM"), signalHandler);
+//        Signal.handle(new Signal("INT"), signalHandler);
+//        Signal.handle(new Signal("TERM"), signalHandler);
     }
 
@@ -44,6 +46,5 @@
             Class type = Class.forName(typeName);
             Constructor constructor = type.getConstructor(Parameters.class);
-            Entity entity = (Entity) constructor.newInstance(parameters);
-            return entity;
+            return (Entity) constructor.newInstance(parameters);
         } catch (Exception e) {
             LOGGER.error("failed to instantiate: " + e);
@@ -96,6 +97,16 @@
         }
 
-        entity = configureEntity(new Parameters(config.subset("com.framsticks.entity"), "main", null));
-        entity.configurePublic();
+        entity = configureEntity(new Parameters(config.subset("com.framsticks.entity"), "main", null, new EntityOwner() {
+			@Override
+			public void onDone() {
+				LOGGER.info("exiting");
+				Runtime.getRuntime().exit(0);
+			}
+		}));
+		try {
+	        entity.configurePublic();
+		} catch (Exception e) {
+			LOGGER.fatal("exception caught during configuration: " + e);
+		}
         LOGGER.info("all entities were configured");
         entity.start();
Index: /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 78)
@@ -23,5 +23,5 @@
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
 
         super.configure();
Index: /java/main/src/main/java/com/framsticks/dumping/FileInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 78)
@@ -53,15 +53,4 @@
     }
 
-
-    @Override
-    protected void fetchInfo(Path path, Future<FramsClass> future) {
-        future.result(null, new UnsupportedOperationException());
-    }
-
-    @Override
-    protected void tryRegisterOnChangeEvents(Path path) {
-    }
-
-
     @Override
     public String toString() {
Index: /java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 78)
@@ -37,7 +37,16 @@
         this.instance = instance;
         this.stateFunctor = stateFunctor;
-        dispatched = 1;
-        write(root);
+		dispatchWrite(root);
     }
+
+	protected void dispatchWrite(final Path path) {
+		++dispatched;
+		instance.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				write(path);
+			}
+		});
+	}
 
     protected void finished() {
@@ -53,4 +62,5 @@
         } else {
             AccessInterface access = instance.bindAccess(path);
+			assert access != null;
             FramsClass framsClass = access.getFramsClass();
             assert framsClass != null;
@@ -76,11 +86,5 @@
                     final Path childPath = path.appendNode(new Node(childParam, access.get(childParam, Object.class)));
                     if (childPath.isResolved() && instance.getInfoFromCache(childPath) != null) {
-                        ++dispatched;
-                        instance.invokeLater(new Runnable() {
-                            @Override
-                            public void run() {
-                                write(childPath);
-                            }
-                        });
+						dispatchWrite(childPath);
                     }
                 }
@@ -92,5 +96,3 @@
         }
     }
-
-
 }
Index: /java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/examples/GenotypeBrowser.java	(revision 78)
@@ -0,0 +1,69 @@
+package com.framsticks.examples;
+
+import com.framsticks.core.Instance;
+import com.framsticks.core.Node;
+import com.framsticks.core.Parameters;
+import com.framsticks.core.Path;
+import com.framsticks.model.*;
+import com.framsticks.model.Package;
+import com.framsticks.params.*;
+import com.framsticks.params.types.CompositeParam;
+import com.framsticks.parsers.F0Parser;
+import com.framsticks.parsers.Schema;
+import org.apache.log4j.Logger;
+
+import java.util.List;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class GenotypeBrowser extends Instance {
+
+	private static final Logger LOGGER = Logger.getLogger(Instance.class.getName());
+	protected Schema schema;
+
+
+	public GenotypeBrowser(Parameters parameters) {
+		super(parameters);
+		LOGGER.info("model builder created");
+	}
+
+	@Override
+	protected void configure() throws Exception {
+		super.configure();
+		schema = new Schema(Schema.getDefaultDefinitionAsStream());
+		this.registry = schema.getRegistry();
+		Package.register(this.getRegistry());
+
+		registry.putInfoIntoCache(new FramsClass("ModelBuilderRoot", "ModelBuilderRoot", null)
+				.append(new ParamBuilder().setType("o Model").setId("f0genotype").setName("f0genotype").build())
+				.append(new ParamBuilder().setType("o F0Model").setId("f0model").setName("f0model").build())
+		);
+		root = new Node((CompositeParam)new ParamBuilder().setType("o ModelBuilderRoot").setId(name).setName("Instance").build(), PropertiesAccess.createPropertiesMap());
+	}
+
+	@Override
+	protected void run() {
+		assert isActive();
+
+		try {
+			List<AccessInterface> accesses = new F0Parser(schema, GenotypeBrowser.class.getResourceAsStream("/examples/f0_example.txt")).parse();
+			List<Object> objects = Util.stripAccessInterface(accesses);
+			F0Genotype f0Genotype = F0Genotype.build(objects);
+			F0Model f0Model = F0Model.build(f0Genotype);
+
+			for (String n : new String[] {"MechPart", "MechJoint", "Neuro"}) {
+				registry.putInfoIntoCache(FramsClass.readFromStream(GenotypeBrowser.class.getResourceAsStream("/info/" + n + ".info")));
+			}
+			AccessInterface rootAccess = bindAccess(new Path(this, "/"));
+
+			rootAccess.set("f0genotype", f0Genotype);
+			rootAccess.set("f0model", f0Model);
+
+		} catch (Exception e) {
+			LOGGER.error("exception caught: " + e);
+		}
+		//done();
+	}
+
+}
Index: /java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 78)
@@ -45,5 +45,5 @@
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
         super.configure();
     }
Index: /java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 78)
@@ -1,4 +1,5 @@
 package com.framsticks.gui;
 
+import com.framsticks.core.Node;
 import com.framsticks.core.Path;
 import com.framsticks.gui.view.*;
@@ -12,4 +13,5 @@
 import javax.swing.tree.*;
 import java.awt.*;
+import java.awt.datatransfer.StringSelection;
 import java.awt.event.ActionEvent;
 import java.awt.event.MouseAdapter;
@@ -75,4 +77,12 @@
         treePopupMenu.add(new JMenuItem("Refresh"));
         treePopupMenu.add(new JMenuItem("Open in new frame as root"));
+		addNodeActionToTreePopupMenu("Copy path to clipboard", new NodeAction() {
+			@Override
+			public void actionPerformed(TreeNode treeNode) {
+				Path path = treeNode.getInstancePath();
+				StringSelection selection = new StringSelection(path.toString());
+				getToolkit().getSystemClipboard().setContents(selection, selection);
+			}
+		});
         //this.add(createMenuItem("Add to favourites", null));
         //this.add(createMenuItem("Remove from favourites", null));
Index: /java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 78)
@@ -124,4 +124,7 @@
         LOGGER.debug("updating children of " + this);
         AccessInterface access = p.getInstance().bindAccess(p.getTop());
+		if (access == null) {
+			return;
+		}
         final List<Path> childrenPaths = new LinkedList<Path>();
         /**Prepare path for each child.*/
@@ -210,5 +213,4 @@
     }
 
-
 	public final Panel getPanel() {
         assert frame.isActive();
@@ -222,5 +224,7 @@
         }
         AccessInterface access = p.getInstance().bindAccess(p);
-        assert access != null;
+		if (access == null) {
+			return;
+		}
         StringBuilder t = new StringBuilder();
         /** html formatting is used here, since tooltips in swing do not support simple \n line breaks */
@@ -494,4 +498,9 @@
 
 		return true;
+	}
+
+	public Path getInstancePath() {
+		assert frame.isActive();
+		return path;
 	}
 
Index: /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java
===================================================================
--- /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/hosting/ServerInstance.java	(revision 78)
@@ -30,8 +30,8 @@
 
     @Override
-    protected void configure() {
+    protected void configure() throws Exception {
         super.configure();
 
-        Parameters p = new Parameters(config.subset("hosted.entity"), "hosted", this);
+        Parameters p = new Parameters(config.subset("hosted.entity"), "hosted", this, null);
         hosted = Program.configureEntity(p);
         if (hosted == null) {
@@ -49,6 +49,7 @@
             return null;
         }
-        if (infoCache.containsKey(id)) {
-            return infoCache.get(id);
+		FramsClass cached = registry.getInfoFromCache(id);
+        if (cached != null) {
+			return cached;
         }
         try {
@@ -56,6 +57,6 @@
             FramsClass framsClass = new FramsClass.Constructor(nativeClass, id).getResult();
 
-            registerReflectedClass(id, nativeClass);
-            putInfoIntoCache(framsClass);
+            registry.registerReflectedClass(null, id, nativeClass);
+            registry.putInfoIntoCache(framsClass);
             return framsClass;
         } catch (ClassNotFoundException ignored) {
Index: /java/main/src/main/java/com/framsticks/model/BaseJoint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BaseJoint.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/model/BaseJoint.java	(revision 78)
@@ -0,0 +1,38 @@
+package com.framsticks.model;
+
+import com.framsticks.util.Point3d;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class BaseJoint {
+
+	/** stif */
+	public Double stiffness;
+	public Double getStif() { return stiffness; }
+	public void setStif(Double stif) { stiffness = stif; }
+
+	/** rotstif */
+	public Double rotationStiffness;
+	public Double getRotstif() { return rotationStiffness; }
+	public void setRotstif(Double rotstif) { rotationStiffness = rotstif; }
+
+	/** rx, ry, rz*/
+	public double rx, ry, rz;
+
+	public Point3d getRotation() { return new Point3d(rx, ry, rz); }
+	public void setRotation(Point3d r) { rx = r.x; ry = r.y; rz = r.z; }
+
+	/** dx, dy, dz*/
+	public double dx, dy, dz;
+
+	public Point3d getDelta() { return new Point3d(dx, dy, dz); }
+	public void setDelta(Point3d d) { dx = d.x; dy = d.y; dz = d.z; }
+
+	public void copyFrom(BaseJoint j) {
+		stiffness = j.stiffness;
+		rotationStiffness = j.rotationStiffness;
+		setRotation(j.getRotation());
+		setDelta(j.getDelta());
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/BaseNeuro.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BaseNeuro.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/model/BaseNeuro.java	(revision 78)
@@ -0,0 +1,16 @@
+package com.framsticks.model;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class BaseNeuro {
+	/** inputCount */
+	public Integer inputCount;
+	public Integer getGetInputCount() { return inputCount; }
+	public void setGetInputCount(Integer getInputCount) { inputCount = getInputCount; }
+
+
+	public void copyFrom(BaseNeuro n) {
+		inputCount = n.inputCount;
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/BasePart.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/BasePart.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/model/BasePart.java	(revision 78)
@@ -0,0 +1,37 @@
+package com.framsticks.model;
+
+import com.framsticks.util.Point3d;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class BasePart {
+	/** x, y, z */
+	public double x, y, z;
+
+	public Point3d getPosition() { return new Point3d(x, y, z); }
+	public void setPosition(Point3d p) { x = p.x; y = p.y; z = p.z; }
+
+	/** m */
+	public Double mass = 0.0;
+	public Double getM() { return mass; }
+	public void setM(Double m) { mass = m; }
+
+	/** s */
+	public Double size = 0.0;
+	public Double getS() { return size; }
+	public void setS(Double s) { size = s; }
+
+	/** fr */
+	public Double friction;
+	public Double getFr() { return friction; }
+	public void setFr(Double fr) { friction = fr; }
+
+
+	public void copyFrom(BasePart p) {
+		setPosition(p.getPosition());
+		mass = p.mass;
+		size = p.size;
+		friction = p.friction;
+	}
+}
Index: /java/main/src/main/java/com/framsticks/model/Creature.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Creature.java	(revision 77)
+++ /java/main/src/main/java/com/framsticks/model/Creature.java	(revision 78)
@@ -1,6 +1,6 @@
 package com.framsticks.model;
 
-import com.framsticks.model.MechPart;
-import com.framsticks.model.Joint;
+import com.framsticks.params.FramsClass;
+import com.framsticks.util.Orientation;
 import com.framsticks.util.Point3d;
 
@@ -8,5 +8,5 @@
 import java.util.List;
 
-public class Creature {
+public class Creature extends F0Model {
 	public String name;
 
@@ -94,35 +94,21 @@
 	public void setVertpos(Double c_vertpos) { averageVerticalPosition = c_vertpos; }
 
-	public Point3d position = new Point3d();
+	/** pos_x, pos_y, pos_z*/
+	public double pos_x, pos_y, pos_z;
 
-	public Double getPos_x() { return position.x; }
-	public void setPos_x(Double pos_x) { position.x = pos_x; }
+	public Point3d getPosition() { return new Point3d(pos_x, pos_y, pos_z) ; }
+	public void setPosition(Point3d pos) { pos_x = pos.x; pos_y = pos.y; pos_z = pos.z; }
 
-	public Double getPos_y() { return position.y; }
-	public void setPos_y(Double pos_y) { position.y = pos_y; }
+	public double size_x, size_y, size_z;
 
-	public Double getPos_z() { return position.z; }
-	public void setPos_z(Double pos_z) { position.z = pos_z; }
+	public Point3d getBoundingBox() { return new Point3d(size_x, size_y, size_z) ; }
+	public void setBoundingBox(Point3d size) { size_x = size.x; size_y = size.y; size_z = size.z; }
 
-	public Point3d boundingBox = new Point3d();
-	public Double getSize_x() { return boundingBox.x; }
-	public void setSize_x(Double size_x) { boundingBox.x = size_x; }
 
-	public Double getSize_y() { return boundingBox.y; }
-	public void setSize_y(Double size_y) { boundingBox.y = size_y; }
+	/** center_x, center_y, center_z*/
+	public double center_x, center_y, center_z;
 
-	public Double getSize_z() { return boundingBox.z; }
-	public void setSize_z(Double size_z) { boundingBox.z = size_z; }
-
-	public Point3d center = new Point3d();
-
-	public Double getCenter_x() { return center.x; }
-	public void setCenter_x(Double center_x) { center.x = center_x; }
-
-	public Double getCenter_y() { return center.y; }
-	public void setCenter_y(Double center_y) { center.y = center_y; }
-
-	public Double getCenter_z() { return center.z; }
-	public void setCenter_z(Double center_z) { center.z = center_z; }
+	public Point3d getCenter() { return new Point3d(center_x, center_y, center_z) ; }
+	public void setCenter(Point3d center) { center_x = center.x; center_y = center.y; center_z = center.z; }
 
 	public Integer getNumparts() { return parts.size(); }
@@ -161,9 +147,18 @@
 	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
 
-	public final List<MechPart> mechparts = new ArrayList<MechPart>();
-	public final List<MechJoint> mechjoints = new ArrayList<MechJoint>();
-	public final List<Neuro> neurons = new ArrayList<Neuro>();
+
+
+	public final List<Part> getParts() { return parts; }
+	public final List<Joint> getJoints() { return joints; }
+	public final List<NeuroDef> getNeuroDefs() { return neurodefs; }
 
 
 
+	public static void constructFramsClass(FramsClass.Constructor constructor) {
+		constructor.field("name");
+		constructor.field("parts");
+		constructor.field("joints");
+		constructor.field("neurodefs");
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/model/F0Genotype.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/F0Genotype.java	(revision 78)
+++ /java/main/src/main/java/com/framsticks/model/F0Genotype.java	(revision 78)
@@ -0,0 +1,75 @@
+package com.framsticks.model;
+
+import com.framsticks.util.Casting;
+import com.framsticks.util.Containers;
+import org.apache.log4j.Logger;
+
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.List;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class F0Genotype {
+
+	private final static Logger LOGGER = Logger.getLogger(F0Genotype.class);
+
+	public Double startingEnergy;
+	public Double getEnerg0() { return startingEnergy; }
+	public void setEnerg0(Double energ0) { startingEnergy = energ0; }
+
+	public Double getSe() { return startingEnergy; }
+	public void setSe(Double se) { startingEnergy = se; }
+
+	/** Vstyle */
+	public String visualizationStyle;
+	public String getVstyle() { return visualizationStyle; }
+	public void setVstyle(String Vstyle) { visualizationStyle = Vstyle; }
+
+	public final List<Part> parts = new ArrayList<Part>();
+	public final List<Joint> joints = new ArrayList<Joint>();
+	public final List<NeuroDef> neurodefs = new ArrayList<NeuroDef>();
+
+	public Double getNumparts() { return (double)parts.size(); }
+	public Double getNumjoints() { return (double)joints.size(); }
+	public Double getNumneurons() { return (double)neurodefs.size(); }
+
+	//this is impossible to use, because numparts field is marked as readonly
+	public void setNumparts(Double numparts) { Containers.resizeList(parts, (int) (double) numparts); }
+	public void setNumjoints(Double numjoints) { Containers.resizeList(joints, (int)(double)numjoints); }
+	public void setNumneurons(Double numneurons) { Containers.resizeList(neurodefs, (int)(double)numneurons); }
+
+	public List<Part> getParts() { return parts; }
+	public List<Joint> getJoints() { return joints; }
+	public List<NeuroDef> getNeuroDefs() { return neurodefs; }
+
+	public static F0Genotype build(List<Object> objects) {
+		Iterator<Object> i = objects.iterator();
+		if (!i.hasNext()) {
+			return null;
+		}
+		F0Genotype f0Genotype = Casting.tryCast(F0Genotype.class, i.next());
+		if (f0Genotype == null) {
+			LOGGER.fatal("first object is not a Model");
+			return null;
+		}
+		while (i.hasNext()) {
+			Object object = i.next();
+			if (object instanceof Joint) {
+				f0Genotype.joints.add((Joint)object);
+				continue;
+			}
+			if (object instanceof Part) {
+				f0Genotype.parts.add((Part)object);
+				continue;
+			}
+			if (object instanceof NeuroDef) {
+				f0Genotype.neurodefs.add((NeuroDef) object);
+				continue;
+			}
+			LOGGER.error("invalid class: " + object.getClass().getCanonicalName());
+		}
+		return f0Genotype;
+	}
+}
